unit UserSessionUnit;

{
  This is a DataModule where you can add components or declare fields that are specific to 
  ONE user. Instead of creating global variables, it is better to use this datamodule. You can then
  access the it using UserSession.
}
interface

uses
  IWUserSessionBase, SysUtils, Classes, WideStrings, DBXFirebird, DB, SqlExpr,
  FMTBcd, Provider, DBClient;

type
  TIWUserSession = class(TIWUserSessionBase)
    sqlConn: TSQLConnection;
    qryTiposAgenda: TSQLQuery;
    dspTiposAgenda: TDataSetProvider;
    qryTiposAgendaCODTIP: TIntegerField;
    qryTiposAgendaNOMTIP: TStringField;
    qryTiposAgendaSITTIP: TStringField;
    qryTiposAgendaINCTIP: TSQLTimeStampField;
    qryTiposAgendaALTTIP: TSQLTimeStampField;
    cdsTiposAgenda: TClientDataSet;
    cdsTiposAgendaCODTIP: TIntegerField;
    cdsTiposAgendaNOMTIP: TStringField;
    cdsTiposAgendaSITTIP: TStringField;
    cdsTiposAgendaINCTIP: TSQLTimeStampField;
    cdsTiposAgendaALTTIP: TSQLTimeStampField;
    qryUsuarios: TSQLQuery;
    qryUsuariosCODUSU: TIntegerField;
    qryUsuariosNOMUSU: TStringField;
    qryUsuariosEMAUSU: TStringField;
    qryUsuariosSENUSU: TStringField;
    qryUsuariosSITUSU: TStringField;
    qryUsuariosINCUSU: TSQLTimeStampField;
    qryUsuariosALTUSU: TSQLTimeStampField;
    dspUsuarios: TDataSetProvider;
    cdsUsuarios: TClientDataSet;
    cdsUsuariosCODUSU: TIntegerField;
    cdsUsuariosNOMUSU: TStringField;
    cdsUsuariosEMAUSU: TStringField;
    cdsUsuariosSENUSU: TStringField;
    cdsUsuariosSITUSU: TStringField;
    cdsUsuariosINCUSU: TSQLTimeStampField;
    cdsUsuariosALTUSU: TSQLTimeStampField;
    qryAgenda: TSQLQuery;
    qryAgendaINIAGE: TSQLTimeStampField;
    qryAgendaCODAGE: TIntegerField;
    qryAgendaTIPAGE: TIntegerField;
    qryAgendaNOMTIP: TStringField;
    qryAgendaCODUSU: TIntegerField;
    qryAgendaNOMUSU: TStringField;
    qryAgendaFIMAGE: TSQLTimeStampField;
    qryAgendaSITAGE: TStringField;
    qryAgendaASSAGE: TStringField;
    qryAgendaCONAGE: TStringField;
    qryAgendaINCAGE: TSQLTimeStampField;
    qryAgendaALTAGE: TSQLTimeStampField;
    dspAgenda: TDataSetProvider;
    cdsAgenda: TClientDataSet;
    cdsAgendaCODAGE: TIntegerField;
    cdsAgendaINIAGE: TSQLTimeStampField;
    cdsAgendaTIPAGE: TIntegerField;
    cdsAgendaNOMTIP: TStringField;
    cdsAgendaCODUSU: TIntegerField;
    cdsAgendaNOMUSU: TStringField;
    cdsAgendaFIMAGE: TSQLTimeStampField;
    cdsAgendaSITAGE: TStringField;
    cdsAgendaASSAGE: TStringField;
    cdsAgendaCONAGE: TStringField;
    cdsAgendaINCAGE: TSQLTimeStampField;
    cdsAgendaALTAGE: TSQLTimeStampField;
    qryLogin: TSQLQuery;
    qryTiposAgendaALERTA: TStringField;
    cdsTiposAgendaALERTA: TStringField;
    procedure cdsTiposAgendaAfterPost(DataSet: TDataSet);
    procedure cdsAgendaAfterInsert(DataSet: TDataSet);
    procedure IWUserSessionBaseCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    /// <summary>
    /// I=Incluir, A=Alterar, C=Concluir
    /// </summary>
    OperacaoAgenda: Char;
    ///<summary>
    ///  Varivel que identifica o nom do usurio que
    ///  logou no sistema.
    ///  </summary>
    UsuarioLogado: String;
  end;

implementation

uses ServerController;

{$R *.dfm}

procedure TIWUserSession.cdsAgendaAfterInsert(DataSet: TDataSet);
begin
  cdsAgendaINIAGE.AsString := FormatDateTime('DD/MM/YYYY HH:NN', Now);
  cdsAgendaFIMAGE.Value := cdsAgendaINIAGE.Value;
  cdsAgendaSITAGE.Value := 'Aberto';
end;

procedure TIWUserSession.cdsTiposAgendaAfterPost(DataSet: TDataSet);
begin
  if TClientDataSet(DataSet).ApplyUpdates(0) <> 0 then
    raise Exception.Create('Erro ao gravar no banco de dados')
  else
    TClientDataSet(DataSet).Refresh;
end;

procedure TIWUserSession.IWUserSessionBaseCreate(Sender: TObject);
begin
  UsuarioLogado := '';
end;

end.
