unit uLogin;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWCompButton,
  Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl,
  IWCompEdit, IWVCLComponent, IWBaseLayoutComponent, IWBaseContainerLayout,
  IWContainerLayout, IWTemplateProcessorHTML, DBXCommon;

type
  TfrmLogin = class(TIWAppForm)
    edtUsuario: TIWEdit;
    edtSenha: TIWEdit;
    btnLogin: TIWButton;
    IWTemplateProcessorHTML1: TIWTemplateProcessorHTML;
    procedure btnLoginAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure edtUsuarioAsyncExit(Sender: TObject; EventParams: TStringList);
  public
  end;

implementation

uses Unit1, ServerController;

{$R *.dfm}

procedure TfrmLogin.btnLoginAsyncClick(Sender: TObject;
  EventParams: TStringList);
var
  js: String;
begin
  {//verifica o login/senha fixos, apenas para teste
  if (edtUsuario.Text <> 'admin@agenda.com') or
     (edtSenha.Text <> 'admin') then
  begin
    WebApplication.ShowMessage('E-mail e/ou Senha Incorretos!');
    //edtUsuario.SetFocus; -> como isto  feito assincronamente,
    //o jeito  fazer via javascript, conforme abaixo:
    js := edtUsuario.HTMLName + 'IWCL.focus();';
    WebApplication.CallBackResponse.AddJavaScriptToExecute(js);
    exit;
  end;}

  //passa os parametros e abre a query
  UserSession.qryLogin.Close;
  UserSession.qryLogin.Params[0].AsString := edtUsuario.Text;
  UserSession.qryLogin.Params[1].AsString := edtSenha.Text;
  UserSession.qryLogin.Open;
  //se no encontrou ninguem, d mensagem e encerra por aqui
  if UserSession.qryLogin.IsEmpty then
  begin
    UserSession.qryLogin.Close;
    WebApplication.ShowMessage(
      'E-mail e/ou Senha Incorretos! ' +
      'Usurio no encontrado.');
    js := edtUsuario.HTMLName + 'IWCL.focus();';
    WebApplication.CallBackResponse.AddJavaScriptToExecute(js);
    exit;  
  end 
  //se encontrou mas no est ativo, mostra mensagem e encerra por aqui
  else if UserSession.qryLogin.FieldByName('SITUSU').AsString <> 'A' then
  begin
    UserSession.qryLogin.Close;
    WebApplication.ShowMessage(
      'O usurio informado est inativo!');
    js := edtUsuario.HTMLName + 'IWCL.focus();';
    WebApplication.CallBackResponse.AddJavaScriptToExecute(js);
    exit;    
  end
  //caso contrrio, apenas fecha a query para economizar recursos
  else
    UserSession.qryLogin.Close;
  

  //destroi o form ativo, frmLogin
  TIWAppForm(WebApplication.ActiveForm).Release;
  //exibe o form solicitado, frmBase (Menu Principal)
  TfrmBase.Create(WebApplication).Show;
end;

procedure TfrmLogin.edtUsuarioAsyncExit(Sender: TObject;
  EventParams: TStringList);
var
  js: String;
begin
  with (Sender as TIWEdit) do
    if (Trim(Text) <> '') and (Pos('@', Text) = 0) then
    begin
      Text := '';
      WebApplication.ShowMessage('O e-mail informado  invlido!');
      js := HTMLName + 'IWCL.focus();';
      WebApplication.CallBackResponse.AddJavaScriptToExecute(js);
    end;
end;

initialization
  TfrmLogin.SetAsMainForm;


end.
