unit uTestUnit;

interface

uses
  TestFramework, SysUtils, uSenha, StrUtils;

type
  TestTSenha = class(TTestCase)
  strict private
    FSenha: TSenha;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure ValidaSenha_Vazia;
    procedure ValidaSenha_MinimoChar;
    procedure ValidaSenha_Maiuscula;
    procedure ValidaSenha_Minuscula;
    procedure ValidaSenha_Numero;
    procedure ValidaSenha_Especial;
    procedure ValidaSenha_SenhaValida;
  end;

implementation

procedure TestTSenha.SetUp;
begin
  FSenha := TSenha.Create;
end;

procedure TestTSenha.TearDown;
begin
  FSenha.Free;
  FSenha := nil;
end;

procedure TestTSenha.ValidaSenha_Especial;
begin
  CheckEquals('Sem caracteres especiais', FSenha.ValidaSenha('TClass28'));
end;

procedure TestTSenha.ValidaSenha_Maiuscula;
begin
  CheckEquals('Sem letras maisculas', FSenha.ValidaSenha('tclass@28'));
end;

procedure TestTSenha.ValidaSenha_MinimoChar;
begin
  CheckEquals('No atingiu o mnimo de 6 caracteres', FSenha.ValidaSenha('Tc@28'));
end;

procedure TestTSenha.ValidaSenha_Minuscula;
begin
  CheckEquals('Sem letras minsculas', FSenha.ValidaSenha('TCLASS@28'));
end;

procedure TestTSenha.ValidaSenha_Numero;
begin
  CheckEquals('Sem numerais', FSenha.ValidaSenha('TClass@'));
end;

procedure TestTSenha.ValidaSenha_SenhaValida;
begin
  CheckEquals('Senha vlida', FSenha.ValidaSenha('TClass@28'));
end;

procedure TestTSenha.ValidaSenha_Vazia;
begin
  CheckEquals('Senha inexistente', FSenha.ValidaSenha(''));
end;

initialization
  // Register any test cases with the test runner
  RegisterTest(TestTSenha.Suite);
end.

